/* This program reads the file BBSFNSW.TXT and removes the BBS registry
  headings and end-of-page characters from it so that it can be displayed
  to online users.  */

#include <stdio.h>
#include <string.h>

#define yes 1
#define no 0
#define num 35


int diskfiles(char[], char[]);
int getone(char []);
void writeit(char []);
int readit(char [], char []);

FILE *fp, *fp2;

char thedata [20] [80];

void main ()
{
	int error, local, loop, wrong, stop, endofdata, a;
	char temp [80];
	char name [80];
	char sysop [80];
	printf("\nReading BBSFNSW.txt\n");
	error = diskfiles("bbsfnsw.txt","bbsf.txt");
	if (error == yes)
		printf("Disk error.  Program aborted.\n");
	else
	{
	   while(error == no)
	   {
		error = readit("     System:",name);
		error = getone(sysop);
		if (strnicmp(sysop,"      Sysop:",12) == 0 && error == no)
		{
				endofdata = 0;
				stop = no;
				while (endofdata < 20 && error == no && stop == no)
				{
					error = getone(temp);
					if (error == no && strcmp(temp,"") != 0 && strncmp(temp,"+---",5) != 0)
					{
						strcpy(thedata[endofdata],temp);
						endofdata ++;
					}
					else
					{
						if (error == no)
						{
							writeit(name);
							writeit(sysop);
							for (a = 0; a < endofdata; a++)
								writeit(thedata[a]);
							writeit("\n");
							stop = yes;
						}
					}
				}
		}
	   }
	}
	fclose(fp);
	fclose(fp2);
	remove ("bbsfnsw.txt");
	rename ("bbsf.txt","bbsfnsw.txt");
	printf("Finished.\n");

}

int diskfiles(char name1[], char name2[])
{
	int error = no;
	fp = fopen(name1,"rt");
	fp2 = fopen(name2,"wt");
	if (fp == NULL || fp2 == NULL)
	{
		printf("Error opening disk files.");
		error = yes;
	}
	return(error);

}

int getone(char temp[])
{
		int error;
		strcpy(temp,"");
		error = fscanf(fp,"%[^\n]",temp);
		if (error != EOF)
		{
			getc(fp);
			error = no;
		}
		else
			error = yes;

		return(error);
}


void writeit(char temp[])
{
	fprintf(fp2,"%s\n",temp);
}

int readit(char search[], char result[])
{
	int error = no;
	int foundit = no;

	while(error == no && foundit == no)
	{
		error = getone(result);
		if (strnicmp(result,search,strlen(search)) == 0)
			foundit = yes;
	}
	return(error);
}
